#!/usr/bin/env python3
# Copyright (C) 2019 @LynnearSoftware@lynnesbian.fedi.space

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.

# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

import markovify
import json
import re, random, multiprocessing, time, sqlite3, shutil, os

class TextFixed(markovify.Text):
	def test_sentence_input(self, sentence):
		return True #all sentences are valid <3

def make_toot():
	try:
		with open("model.json") as f:
			jmodel = f.read()
	except:
		print("Couldn't load model.json. Please run main.py to regenerate it.")
		raise

	model = TextFixed.from_json(jmodel)
	sentence = None
	while sentence is None:
		sentence = model.make_short_sentence(500, tries=10000)

	return sentence
